Loading...
Searching...
No Matches
casacore::PlainTable Class Reference
tables package (libcasa_tables) » Tables_module » Tables_module_internal_classes

More...

`#include <PlainTable.h>`

## Public Member Functions

| PlainTable (SetupNewTable &, rownr_t nrrow, Bool initialize, const TableLock &lockOptions, int endianFormat, const TSMOption &tsmOption)
| Construct the object for a new table.
| PlainTable (MPI_Comm mpiComm, SetupNewTable &, rownr_t nrrow, Bool initialize, const TableLock &lockOptions, int endianFormat, const TSMOption &tsmOption)
| MPI version of the constructor.
void | PlainTableCommon (SetupNewTable &, rownr_t nrrow, Bool initialize, const TableLock &lockOptions, int endianFormat, const TSMOption &tsmOption)
| Common part of the constructor shared by MPI and non-MPI.
| PlainTable (AipsIO &, uInt version, const String &name, const String &type, rownr_t nrrow, int option, const TableLock &lockOptions, const TSMOption &tsmOption, Bool addToCache, uInt locknr)
| Construct the object for an existing table.
virtual | ~PlainTable ()
| The destructor flushes (i.e.
| PlainTable (const PlainTable &)=delete
| Copy constructor is forbidden, because copying a table requires some more knowledge (like table name of result).
PlainTable & | operator= (const PlainTable &)=delete
| Assignment is forbidden, because copying a table requires some more knowledge (like table name of result).
virtual void | reopenRW ()
| Try to reopen the table for read/write access.
virtual void | changeTiledDataOnly ()
| Indicate we will only modify data values in existing tiled columns.
virtual Bool | asBigEndian () const
| Is the table stored in big or little endian format?
virtual const StorageOption & | storageOption () const
| Get the storage option used for the table.
virtual Bool | isMultiUsed (Bool checkSubTables) const
| Is the table in use (i.e.
virtual const TableLock & | lockOptions () const
| Get the locking info.
virtual void | mergeLock (const TableLock &lockOptions)
| Merge the given lock info with the existing one.
virtual Bool | hasLock (FileLocker::LockType) const
| Has this process the read or write lock, thus can the table be read or written safely?
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Try to lock the table for read or write access.
virtual void | unlock ()
| Unlock the table.
void | autoReleaseLock (Bool always=False)
| Do a release of an AutoLock when the inspection interval has expired.
virtual void | flush (Bool fsync, Bool recursive)
| Flush the table, i.e.
virtual void | resync ()
| Resync the Table object with the table file.
virtual uInt | getModifyCounter () const
| Get the modify counter.
virtual void | setTableChanged ()
| Set the table to being changed.
virtual Bool | isWritable () const
| Test if the table is opened as writable.
virtual TableDesc | actualTableDesc () const
| Get the actual table description.
virtual Record | dataManagerInfo () const
| Get the data manager info.
virtual TableRecord & | keywordSet ()
| Get readonly access to the table keyword set.
virtual TableRecord & | rwKeywordSet ()
| Get read/write access to the table keyword set.
virtual BaseColumn * | getColumn (uInt columnIndex) const
| Get a column object using its index.
virtual BaseColumn * | getColumn (const String &columnName) const
| Get a column object using its name.
virtual Bool | canAddRow () const
| Test if it is possible to add a row to this table.
virtual void | addRow (rownr_t nrrow, Bool initialize)
| Add one or more rows and possibly initialize them.
virtual Bool | canRemoveRow () const
| Test if it is possible to remove a row from this table.
virtual void | removeRow (rownr_t rownr)
| Remove the given row.
virtual void | addColumn (const ColumnDesc &columnDesc, Bool)
| Add a column to the table.
virtual void | addColumn (const ColumnDesc &columnDesc, const String &dataManager, Bool byName, Bool)
virtual void | addColumn (const ColumnDesc &columnDesc, const DataManager &dataManager, Bool)
virtual void | addColumn (const TableDesc &tableDesc, const DataManager &dataManager, Bool)
virtual Bool | canRemoveColumn (const Vector< String > &columnNames) const
| Test if columns can be removed.
virtual void | removeColumn (const Vector< String > &columnNames)
| Remove columns.
virtual Bool | canRenameColumn (const String &columnName) const
| Test if a column can be renamed (yes).
virtual void | renameColumn (const String &newName, const String &oldName)
| Rename a column.
virtual void | renameHypercolumn (const String &newName, const String &oldName)
| Rename a hypercolumn.
virtual DataManager * | findDataManager (const String &name, Bool byColumn) const
| Find the data manager with the given name or for the given column.
Public Member Functions inherited from casacore::BaseTable
| BaseTable (const String &tableName, int tableOption, rownr_t nrrow)
| Initialize the object.
| BaseTable (MPI_Comm mpiComm, const String &tableName, int tableOption, rownr_t nrrow)
| MPI version of the constructor.
void | BaseTableCommon (const String &tableName, int tableOption, rownr_t nrrow)
| Common code shared by the MPI constructor and non-MPI constructor.
virtual | ~BaseTable ()
| The destructor will delete the table if needed.
| BaseTable (const BaseTable &)=delete
| Copy constructor is forbidden, because copying a table requires some more knowledge (like table name of result).
BaseTable & | operator= (const BaseTable &)=delete
| Assignment is forbidden, because copying a table requires some more knowledge (like table name of result).
virtual Bool | isNull () const
| Is the table a null table?
void | doNotWrite ()
| Do not write the table (used in in case of exceptions).
Bool | isColumnWritable (const String &columnName) const
| Test if the given column is writable.
Bool | isColumnWritable (uInt columnIndex) const
Bool | isColumnStored (const String &columnName) const
| Test if the given column is stored (otherwise it is virtual).
Bool | isColumnStored (uInt columnIndex) const
const String & | tableName () const
| Get the table name.
virtual void | getPartNames (Block< String > &names, Bool recursive) const
| Get the names of the tables this table consists of.
virtual void | rename (const String &newName, int tableOption)
| Rename the table.
virtual void | copy (const String &newName, int tableOption) const
| Copy the table and all its subtables.
virtual void | deepCopy (const String &newName, const Record &dataManagerInfo, const StorageOption &, int tableOption, Bool valueCopy, int endianFormat, Bool noRows) const
virtual int | tableType () const
| Get the table type.
int | tableOption () const
| Get the table option.
void | markForDelete (Bool callback, const String &oldName)
| Mark the table for delete.
void | unmarkForDelete (Bool callback, const String &oldName)
| Unmark the table for delete.
Bool | isMarkedForDelete () const
| Test if the table is marked for delete.
const TableDesc & | tableDesc () const
| Get the table description.
void | showStructure (std::ostream &, Bool showDataMan, Bool showColumns, Bool showSubTables, Bool sortColumns, Bool cOrder)
| Show the table structure (implementation of Table::showStructure).
TableInfo & | tableInfo ()
| Get access to the TableInfo object.
virtual void | flushTableInfo ()
| Write the TableInfo object.
rownr_t | nrow () const
| Get number of rows.
void | removeRow (const Vector< rownr_t > &rownrs)
void | removeRow (const Vector< uInt > &rownrs)
std::shared_ptr< BaseTable > | select (const TableExprNode &, rownr_t maxRow, rownr_t offset)
| Select rows using the given expression (which can be null).
std::shared_ptr< BaseTable > | select (rownr_t maxRow, rownr_t offset)
| Select maxRow rows and skip first offset rows.
std::shared_ptr< BaseTable > | select (const Vector< rownr_t > &rownrs)
| Select rows using a vector of row numbers.
std::shared_ptr< BaseTable > | select (const Block< Bool > &mask)
| Select rows using a mask block.
std::shared_ptr< BaseTable > | project (const Block< String > &columnNames)
| Project the given columns (i.e.
std::shared_ptr< BaseTable > | tabAnd (BaseTable *)
| Do logical operations on a table.
std::shared_ptr< BaseTable > | tabOr (BaseTable *)
| union with another table
std::shared_ptr< BaseTable > | tabSub (BaseTable *)
| subtract another table
std::shared_ptr< BaseTable > | tabXor (BaseTable *)
| xor with another table
std::shared_ptr< BaseTable > | tabNot ()
| take complement
std::shared_ptr< BaseTable > | sort (const Block< String > &columnNames, const Block< std::shared_ptr< BaseCompare > > &compareObjects, const Block< Int > &sortOrder, int sortOption, std::shared_ptr< Vector< rownr_t > > sortIterBoundaries=nullptr, std::shared_ptr< Vector< size_t > > sortIterKeyIdxChange=nullptr)
| Sort a table on one or more columns of scalars.
BaseTableIterator * | makeIterator (const Block< String > &columnNames, const Block< std::shared_ptr< BaseCompare > > &, const Block< Int > &orders, int option, bool cacheIterationBoundaries=false)
| Create an iterator.
void | addColumns (const TableDesc &tableDesc, const Record &dmInfo, Bool addToParent)
| Add one or more columns to the table.
Bool | checkRemoveColumn (const Vector< String > &columnNames, Bool throwException) const
| Check if the set of columns can be removed.
virtual Vector< rownr_t > | rowNumbers () const
| Get a vector of row numbers.
virtual BaseTable * | root ()
| Get pointer to root table (i.e.
virtual Bool | rowOrder () const
| Tell if the table is in row order.
virtual Vector< rownr_t > & | rowStorage ()
| By the default the table cannot return the storage of rownrs.
virtual Bool | adjustRownrs (rownr_t nrrow, Vector< rownr_t > &rownrs, Bool determineOrder) const
| Adjust the row numbers to be the actual row numbers in the root table.
virtual std::shared_ptr< BaseTable > | doSort (PtrBlock< BaseColumn * > &, const Block< std::shared_ptr< BaseCompare > > &, const Block< Int > &sortOrder, int sortOption, std::shared_ptr< Vector< rownr_t > > sortIterBoundaries, std::shared_ptr< Vector< size_t > > sortIterKeyIdxChange)
| Do the actual sort.
std::shared_ptr< RefTable > | makeRefTable (Bool rowOrder, rownr_t initialNrrow)
| Create a RefTable object.
void | checkRowNumber (rownr_t rownr) const
| Check if the row number is valid.
int | traceId () const
| Get the table's trace-id.

## Static Public Member Functions

static void | getLayout (TableDesc &desc, AipsIO &ios)
| Return the layout of a table (i.e.
static ByteIO::OpenOption | toAipsIOFoption (int tableOption)
| Convert a Table option to an AipsIO file option.
static TableCache & | tableCache ()
| Get access to the TableCache.
Static Public Member Functions inherited from casacore::BaseTable
static TableInfo | tableInfo (const String &tableName)
| Get the table info of the table with the given name.

## Private Member Functions

void | closeObject ()
| Close the object which is called by the destructor.
virtual void | renameSubTables (const String &newName, const String &oldName)
| Rename the subtables (used by rename function).
MemoryIO * | doReleaseCallBack (Bool always)
Bool | putFile (Bool always)
| When needed, write the table control information in an AipsIO file.
void | syncTable ()
| Synchronize the table after having acquired a lock which says that main table data has changed.
void | setEndian (int endianFormat)
| Determine and set the endian format (big or little).
void | checkWritable (const char *func) const
| Throw an exception if the table is not writable.

## Static Private Member Functions

static MemoryIO * | releaseCallBack (void *plainTableObject, Bool always)
| The callback function when a lock is released.

## Private Attributes

std::shared_ptr< ColumnSet > | colSetPtr_p
Bool | tableChanged_p
Bool | addToCache_p
TableLockData * | lockPtr_p
TableSyncData | lockSync_p
Bool | bigEndian_p
TSMOption | tsmOption_p
Bool | changeTiledDataOnly_

## Static Private Attributes

static TableCache | theirTableCache

## Additional Inherited Members

Protected Member Functions inherited from casacore::BaseTable
void | scratchCallback (Bool isScratch, const String &oldName) const
| Do the callback for scratch tables (if callback is set).
Bool | makeTableDir ()
| Create the table directory when needed (and possible).
void | trueDeepCopy (const String &newName, const Record &dataManagerInfo, const StorageOption &, int tableOption, int endianFormat, Bool noRows) const
| Make a true deep copy of the table.
void | prepareCopyRename (const String &newName, int tableOption) const
| Prepare for copying or renaming a table.
void | throwIfTableExists ()
| Check if the table already exists.
Bool | openedForWrite () const
| Test if the table is opened for write.
void | writeStart (AipsIO &, Bool bigEndian)
| Start writing a table.
void | writeEnd (AipsIO &)
| End writing a table.
Bool | shouldNotWrite () const
| Should the table be written.
void | getTableInfo ()
| Read the TableInfo object.
Protected Attributes inherited from casacore::BaseTable
std::weak_ptr< BaseTable > | thisPtr_p
rownr_t | nrrow_p
rownr_t | nrrowToAdd_p
std::shared_ptr< TableDesc > | tdescPtr_p
String | name_p
int | option_p
Bool | noWrite_p
Bool | delete_p
TableInfo | info_p
Bool | madeDir_p
int | itsTraceId

## Detailed Description

Class defining a plain regular table

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- BaseTable
- BaseColumn

### Etymology

PlainTable represents a plain regular table. This is opposed to a RefTable, which is a view on a PlainTable.

### Synopsis

PlainTable is a table consisting of a keyword set and a number of filled and virtual columns. The table control information and the keyword set is stored in an AipsIO file. The data in the filled columns are stored separately by storage managers.
The PlainTable class structure is shown in this UML diagram.

### To Do

- notify RefTable's when deleting rows

Definition at line 85 of file PlainTable.h.

## Constructor & Destructor Documentation

## PlainTable() [1/4]

casacore::PlainTable::PlainTable | ( | SetupNewTable & | ,
|  | rownr_t | nrrow,
|  | Bool | initialize,
|  | const TableLock & | lockOptions,
|  | int | endianFormat,
|  | const TSMOption & | tsmOption )

Construct the object for a new table.

It creates storage manager(s) for unbound columns and initializes all storage managers. The given number of rows is stored in the table and initialized if the flag is set.

References lockOptions().

Referenced by operator=(), and PlainTable().

## PlainTable() [2/4]

casacore::PlainTable::PlainTable | ( | MPI_Comm | mpiComm,
|  | SetupNewTable & | ,
|  | rownr_t | nrrow,
|  | Bool | initialize,
|  | const TableLock & | lockOptions,
|  | int | endianFormat,
|  | const TSMOption & | tsmOption )

MPI version of the constructor.

References lockOptions().

## PlainTable() [3/4]

casacore::PlainTable::PlainTable | ( | AipsIO & | ,
|  | uInt | version,
|  | const String & | name,
|  | const String & | type,
|  | rownr_t | nrrow,
|  | int | option,
|  | const TableLock & | lockOptions,
|  | const TSMOption & | tsmOption,
|  | Bool | addToCache,
|  | uInt | locknr )

Construct the object for an existing table.

It opens the table file, reads the table control information and creates and initializes the required storage managers.

References lockOptions(), and casacore::name().

## ~PlainTable()

virtual casacore::PlainTable::~PlainTable | ( |  | ) |

virtual

The destructor flushes (i.e.

writes) the table if it is opened for output and not marked for delete.

## PlainTable() [4/4]

casacore::PlainTable::PlainTable | ( | const PlainTable & |  | ) |

delete

Copy constructor is forbidden, because copying a table requires some more knowledge (like table name of result).

References PlainTable().

## Member Function Documentation

## actualTableDesc()

virtual TableDesc casacore::PlainTable::actualTableDesc | ( |  | ) | const

virtual

Get the actual table description.

Implements casacore::BaseTable.

## addColumn() [1/4]

virtual void casacore::PlainTable::addColumn | ( | const ColumnDesc & | columnDesc,
|  | Bool | )

virtual

Add a column to the table.

The last Bool argument is not used in PlainTable, but can be used in other classes derived from BaseTable.

Reimplemented from casacore::BaseTable.

## addColumn() [2/4]

virtual void casacore::PlainTable::addColumn | ( | const ColumnDesc & | columnDesc,
|  | const DataManager & | dataManager,
|  | Bool | )

virtual

Reimplemented from casacore::BaseTable.

## addColumn() [3/4]

virtual void casacore::PlainTable::addColumn | ( | const ColumnDesc & | columnDesc,
|  | const String & | dataManager,
|  | Bool | byName,
|  | Bool | )

virtual

Reimplemented from casacore::BaseTable.

## addColumn() [4/4]

virtual void casacore::PlainTable::addColumn | ( | const TableDesc & | tableDesc,
|  | const DataManager & | dataManager,
|  | Bool | )

virtual

Reimplemented from casacore::BaseTable.

References casacore::BaseTable::tableDesc().

## addRow()

virtual void casacore::PlainTable::addRow | ( | rownr_t | nrrow,
|  | Bool | initialize )

virtual

Add one or more rows and possibly initialize them.

This will fail for tables not supporting addition of rows.

Reimplemented from casacore::BaseTable.

## asBigEndian()

virtual Bool casacore::PlainTable::asBigEndian | ( |  | ) | const

virtual

Is the table stored in big or little endian format?

Implements casacore::BaseTable.

## autoReleaseLock()

void casacore::PlainTable::autoReleaseLock | ( | Bool | always = False | ) |

Do a release of an AutoLock when the inspection interval has expired.

always=True means that the inspection is always done, thus not every 25th call or so.

References casacore::False.

## canAddRow()

virtual Bool casacore::PlainTable::canAddRow | ( |  | ) | const

virtual

Test if it is possible to add a row to this table.

Reimplemented from casacore::BaseTable.

## canRemoveColumn()

virtual Bool casacore::PlainTable::canRemoveColumn | ( | const Vector< String > & | columnNames | ) | const

virtual

Test if columns can be removed.

Implements casacore::BaseTable.

## canRemoveRow()

virtual Bool casacore::PlainTable::canRemoveRow | ( |  | ) | const

virtual

Test if it is possible to remove a row from this table.

Reimplemented from casacore::BaseTable.

## canRenameColumn()

virtual Bool casacore::PlainTable::canRenameColumn | ( | const String & | columnName | ) | const

virtual

Test if a column can be renamed (yes).

Implements casacore::BaseTable.

## changeTiledDataOnly()

virtual void casacore::PlainTable::changeTiledDataOnly | ( |  | ) |

virtual

Indicate we will only modify data values in existing tiled columns.

Reimplemented from casacore::BaseTable.

## checkWritable()

void casacore::PlainTable::checkWritable | ( | const char * | func | ) | const

private

Throw an exception if the table is not writable.

## closeObject()

void casacore::PlainTable::closeObject | ( |  | ) |

private

Close the object which is called by the destructor.

## dataManagerInfo()

virtual Record casacore::PlainTable::dataManagerInfo | ( |  | ) | const

virtual

Get the data manager info.

Implements casacore::BaseTable.

References casacore::Record().

## doReleaseCallBack()

MemoryIO * casacore::PlainTable::doReleaseCallBack | ( | Bool | always | ) |

private

## findDataManager()

virtual DataManager * casacore::PlainTable::findDataManager | ( | const String & | name,
|  | Bool | byColumn ) const

virtual

Find the data manager with the given name or for the given column.

Implements casacore::BaseTable.

References casacore::name().

## flush()

virtual void casacore::PlainTable::flush | ( | Bool | fsync,
|  | Bool | recursive )

virtual

Flush the table, i.e.

write it to disk. Nothing will be done if the table is not writable. A flush can be executed at any time. When a table is marked for delete, the destructor will remove files written by intermediate flushes. Note that if necessary the destructor will do an implicit flush, unless it is executed due to an exception.

Implements casacore::BaseTable.

## getColumn() [1/2]

virtual BaseColumn * casacore::PlainTable::getColumn | ( | const String & | columnName | ) | const

virtual

Get a column object using its name.

Implements casacore::BaseTable.

## getColumn() [2/2]

virtual BaseColumn * casacore::PlainTable::getColumn | ( | uInt | columnIndex | ) | const

virtual

Get a column object using its index.

Implements casacore::BaseTable.

## getLayout()

void casacore::PlainTable::getLayout | ( | TableDesc & | desc,
|  | AipsIO & | ios )

static

Return the layout of a table (i.e.

description and #rows). This function has the advantage that only the minimal amount of information required is read from the table, thus it is much faster than a normal table open.
The number of rows is returned. The description of the table is stored in desc (its contents will be overwritten).

## getModifyCounter()

virtual uInt casacore::PlainTable::getModifyCounter | ( |  | ) | const

virtual

Get the modify counter.

Implements casacore::BaseTable.

## hasLock()

virtual Bool casacore::PlainTable::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Has this process the read or write lock, thus can the table be read or written safely?

Implements casacore::BaseTable.

## isMultiUsed()

virtual Bool casacore::PlainTable::isMultiUsed | ( | Bool | checkSubTables | ) | const

virtual

Is the table in use (i.e.

open) in another process? If checkSubTables is set, it is also checked if a subtable is used in another process.

Implements casacore::BaseTable.

## isWritable()

virtual Bool casacore::PlainTable::isWritable | ( |  | ) | const

virtual

Test if the table is opened as writable.

Implements casacore::BaseTable.

## keywordSet()

virtual TableRecord & casacore::PlainTable::keywordSet | ( |  | ) |

virtual

Get readonly access to the table keyword set.

Implements casacore::BaseTable.

## lock()

virtual Bool casacore::PlainTable::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Try to lock the table for read or write access.

Implements casacore::BaseTable.

## lockOptions()

virtual const TableLock & casacore::PlainTable::lockOptions | ( |  | ) | const

virtual

Get the locking info.

Implements casacore::BaseTable.

Referenced by mergeLock(), PlainTable(), PlainTable(), PlainTable(), and PlainTableCommon().

## mergeLock()

virtual void casacore::PlainTable::mergeLock | ( | const TableLock & | lockOptions | ) |

virtual

Merge the given lock info with the existing one.

Implements casacore::BaseTable.

References lockOptions().

## operator=()

PlainTable & casacore::PlainTable::operator= | ( | const PlainTable & |  | ) |

delete

Assignment is forbidden, because copying a table requires some more knowledge (like table name of result).

References PlainTable().

## PlainTableCommon()

void casacore::PlainTable::PlainTableCommon | ( | SetupNewTable & | ,
|  | rownr_t | nrrow,
|  | Bool | initialize,
|  | const TableLock & | lockOptions,
|  | int | endianFormat,
|  | const TSMOption & | tsmOption )

Common part of the constructor shared by MPI and non-MPI.

References lockOptions().

## putFile()

Bool casacore::PlainTable::putFile | ( | Bool | always | ) |

private

When needed, write the table control information in an AipsIO file.

Tell the storage managers to flush and close their files. It returns a switch to tell if the table control information has been written.

## releaseCallBack()

MemoryIO * casacore::PlainTable::releaseCallBack | ( | void * | plainTableObject,
|  | Bool | always )

static private

The callback function when a lock is released.

This flushes the table data, writes the synchronization data into the MemoryIO object, and returns a pointer to it.

## removeColumn()

virtual void casacore::PlainTable::removeColumn | ( | const Vector< String > & | columnNames | ) |

virtual

Remove columns.

Implements casacore::BaseTable.

## removeRow()

virtual void casacore::PlainTable::removeRow | ( | rownr_t | rownr | ) |

virtual

Remove the given row.

This will fail for tables not supporting removal of rows.

Reimplemented from casacore::BaseTable.

## renameColumn()

virtual void casacore::PlainTable::renameColumn | ( | const String & | newName,
|  | const String & | oldName )

virtual

Rename a column.

Implements casacore::BaseTable.

## renameHypercolumn()

virtual void casacore::PlainTable::renameHypercolumn | ( | const String & | newName,
|  | const String & | oldName )

virtual

Rename a hypercolumn.

Implements casacore::BaseTable.

## renameSubTables()

virtual void casacore::PlainTable::renameSubTables | ( | const String & | newName,
|  | const String & | oldName )

private virtual

Rename the subtables (used by rename function).

Reimplemented from casacore::BaseTable.

## reopenRW()

virtual void casacore::PlainTable::reopenRW | ( |  | ) |

virtual

Try to reopen the table for read/write access.

An exception is thrown if the table is not writable. Nothing is done if the table is already open for read/write.

Implements casacore::BaseTable.

## resync()

virtual void casacore::PlainTable::resync | ( |  | ) |

virtual

Resync the Table object with the table file.

Implements casacore::BaseTable.

## rwKeywordSet()

virtual TableRecord & casacore::PlainTable::rwKeywordSet | ( |  | ) |

virtual

Get read/write access to the table keyword set.

This requires that the table is locked (or it gets locked when using AutoLocking mode).

Implements casacore::BaseTable.

## setEndian()

void casacore::PlainTable::setEndian | ( | int | endianFormat | ) |

private

Determine and set the endian format (big or little).

## setTableChanged()

virtual void casacore::PlainTable::setTableChanged | ( |  | ) |

virtual

Set the table to being changed.

Reimplemented from casacore::BaseTable.

## storageOption()

virtual const StorageOption & casacore::PlainTable::storageOption | ( |  | ) | const

virtual

Get the storage option used for the table.

Implements casacore::BaseTable.

## syncTable()

void casacore::PlainTable::syncTable | ( |  | ) |

private

Synchronize the table after having acquired a lock which says that main table data has changed.

It check if the columns did not change. It updates the table and column keywords.

## tableCache()

TableCache & casacore::PlainTable::tableCache | ( |  | ) |

inline static

Get access to the TableCache.

Definition at line 271 of file PlainTable.h.

References theirTableCache.

## toAipsIOFoption()

ByteIO::OpenOption casacore::PlainTable::toAipsIOFoption | ( | int | tableOption | ) |

static

Convert a Table option to an AipsIO file option.

This is used by storage managers.

References casacore::BaseTable::tableOption().

## unlock()

virtual void casacore::PlainTable::unlock | ( |  | ) |

virtual

Unlock the table.

This will also synchronize the table data, thus force the data to be written to disk.

Implements casacore::BaseTable.

## Member Data Documentation

## addToCache_p

Bool casacore::PlainTable::addToCache_p

private

Definition at line 311 of file PlainTable.h.

## bigEndian_p

Bool casacore::PlainTable::bigEndian_p

private

Definition at line 314 of file PlainTable.h.

## changeTiledDataOnly_

Bool casacore::PlainTable::changeTiledDataOnly_

private

Definition at line 317 of file PlainTable.h.

## colSetPtr_p

std::shared_ptr<ColumnSet> casacore::PlainTable::colSetPtr_p

private

Definition at line 309 of file PlainTable.h.

## lockPtr_p

TableLockData* casacore::PlainTable::lockPtr_p

private

Definition at line 312 of file PlainTable.h.

## lockSync_p

TableSyncData casacore::PlainTable::lockSync_p

private

Definition at line 313 of file PlainTable.h.

## tableChanged_p

Bool casacore::PlainTable::tableChanged_p

private

Definition at line 310 of file PlainTable.h.

## theirTableCache

TableCache casacore::PlainTable::theirTableCache

static private

Definition at line 319 of file PlainTable.h.

Referenced by tableCache().

## tsmOption_p

TSMOption casacore::PlainTable::tsmOption_p

private

Definition at line 316 of file PlainTable.h.

The documentation for this class was generated from the following file:

- tables/Tables/PlainTable.h